import request from '@/utils/request'
import { defineStore } from 'pinia'
import { computed, ref, watch } from 'vue'

interface UserInfo {
  id: string
  username: string
  created: string
  vipUntil: string
  gender: number
  birthday: string
  brief: string
  email: string
  password: string
  type: string
  updated: string
  avatar: string
  openId: string
}

export default defineStore('user', () => {
  const token = ref(localStorage.getItem('token') || '')
  watch(token, (val) => {
    localStorage.setItem('token', val)
  })
  const profile = ref<null | UserInfo>(null)
  watch(
    token,
    (val) => {
      if (!val) return
      request<UserInfo>('GET', '/api/profile').then((res) => {
        profile.value = res
      })
    },
    { immediate: true }
  )
  const isLogin = computed(() => !!token.value && !!profile.value)
  return {
    token,
    profile,
    isLogin
  }
})
